package com.school.project.service.implementation;

import com.school.project.dto.TeacherDTO;
import com.school.project.mapper.TeacherMapper;
import com.school.project.model.Teacher;
import com.school.project.repository.TeacherRepository;
import com.school.project.service.interfaces.TeacherService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Optional;

@Service
public class TeacherServiceImp implements TeacherService {

    @Autowired(required = true)
    private TeacherRepository teacherRepository;

    @Autowired
    private TeacherMapper teacherMapper;

    @Override
    public TeacherDTO saveTeacher(TeacherDTO teacherDTO) {
        return teacherMapper.teacherModelToDTo(
                teacherRepository.save(
                        teacherMapper.teacherDTOToModel(teacherDTO)));
    }

    @Override
    public List<TeacherDTO> readAllTeachers() {
        return teacherMapper.teacherModelToDTo(teacherRepository.findAll());
    }

    @Override
    public TeacherDTO readTeacherById(Long id) {
        return teacherMapper.teacherModelToDTo(teacherRepository.findById(id).get());
    }

    @Override
    public TeacherDTO updateTeacher(TeacherDTO teacherDTO, Long id) {
        TeacherDTO dto = readTeacherById(id);

        if (teacherDTO.getName() != null) {
            dto.setName(teacherDTO.getName());
        }
        if (teacherDTO.getDegree() != null) {
            dto.setDegree(teacherDTO.getDegree());
        }
        if (teacherDTO.getCourseList() != null) {
            dto.setCourseList(teacherDTO.getCourseList());
        }
        if (teacherDTO.getDepartment() != null) {
            dto.setDepartment(teacherDTO.getDepartment());
        }

        return saveTeacher(dto);
    }

    @Override
    public void deleteTeacherById(Long id) {
        teacherRepository.deleteById(id);
    }
}
